;------------   Exemple de mise en eouvre d'un ADC avec un PIC 18F4520    ---------------
; Titre : Exercice dapplication
; Date : 20 Mars 2011
; Auteur : P.M
; PIC utilis : PIC 18 F 4520
; On vient lire la valeur d'une entre logique puis on incrmente un registre
; avant de transfrer le contenu vers le port B du PIC. Le quartz utilis est de 4Mhz.
; On ralise une temporisation seconde entre chaque lecture d'un appui

;------------   Directive d' assemblage pour MPLAB   ---------------
	list	p=18f4520
	#include p18f4520.inc
	errorlevel - 302
;------------   Dfinition des constantes   ---------------

#define inter PORTD,0	   ; bouton marche
					
;------------   Dfinition des registres temporaires   ---------------

retard1      EQU    0x80    ; le registre temporaire retard1 se trouve  l' adresse 80
retard2      EQU    0x81    ; le registre temporaire retard2 se trouve  l' adresse 81
memo		 EQU    0x82    ; le registre temporaire memo se trouve  l' adresse 82

;------------   Init des ports B et D   ---------------

	MOVLW 0x00     			; on met 00 dans le registre W.
	MOVWF TRISB           	; on met 00 dans le port B il est programm en sortie.
	MOVLW 0xFF            	; on met FF dans le registre W.
	MOVWF TRISD          	; on met FF dans le port D il est programm en entre.
	clrf PORTB            	; RAZ du port B.
	clrf memo          		; RAZ de la variable memo
	
;------------   Programme principal   ---------------
debut

		btfss inter         ; interrupteur ( marche ) appuy ? si oui on continu sinon 
	        		        ; on retourne  l'tiquette debut
		goto debut
relache		
		btfsc inter         ; interrupteur ( marche ) relach ? si oui on continu sinon 
	        		        ; on retourne  l'tiquette relache
		goto relache
		incf memo,F			; on incrmente le registre memo
		movf memo,W			; copie de memo dans le registre de travail W
		movwf PORTB			; copie du registre w sur le PORTB (W-> port B)
        CALL  tempo        	; on appel la temporisation
		GOTO  debut         ; retour au dbut du programme

;------------   Programme de temporisation ( 0.2 s )   ---------------
tempo
         MOVLW  0xFF        ; on met 255 dans le registre W
         MOVWF  retard1     ; on charge retard1 avec 255 ( FFh contenu du registre W )
         MOVLW  0xFF        ; on met 255 dans le registre W
         MOVWF  retard2     ; on charge retard2 avec 255 ( FFh contenu du registre W )
tempor 
		 DECFSZ retard1,F   ; on dcrmente retard1 et on saute la prochaine instruction si 
         GOTO  tempor       ; le registre retard1 = 0 sinon retour  tempor
         MOVLW 0xFF         ; on met 255 dans le registre W
         MOVWF retard1      ; on charge retard1 avec 255 ( FFh contenu du registre W )
	     DECFSZ retard2,F   ; on dcrmente retard2 et on saute la prochaine instruction si 
         GOTO  tempor       ; le registre retard2 = 0 sinon retour  tempor
         RETURN             ; retour au programme principal aprs l 'instruction CALL

         END                ; fin du programme
