'*********************************************************
' Apprendre la programmation des PIC II                  *
' Projet N 2                                            *
' Exemple de gestion d'une liaison srie                 *
' Pic utilis : 18 F 4520                                *
' Quartz : 4 Mhz                                         *
' Version 1.0 du 20 mars 2011                            *
' Auteur PM                                              *
'*********************************************************


'************ Directives **************
	
    Device 18F4520          ' Pic utilis
    XTAL = 20          
    Declare serial_data 8  
    Symbol T9600 = 84	NO_LIST
       
'************ Variables **************

    Dim donnee As Byte      ' donne reue sur LS 
    Dim donnee_ana As Word  ' donne de conversion analogique numrique
    Dim marche As Bit       ' variable utilise pour mise en service
    Dim tableau[2] As Byte  ' tableau o seront stocks les octets issus de la LS

'************ Variables **************

    Symbol led =PORTC.0     ' la led est connecte sur la broche 0 du Port C (RC0)

'******* registres de direction *******

    TRISB = 0              ' le Port B est dclar en sortie (pilotage relais ou leds)
    TRISC=%10000000        ' le Port C est dclar en sortie sauf RC7 en entre (RX LS)
    clrf PORTB             ' Raz du port B par scurit
    Low led                ' Extinction de la led
    marche = 0             ' Initialisation de la variable marche  0 (platine hors service)
                
debut:
   'Attente d'un caractre 'n' sur la liaison srie
   SerIn PORTC.7 , T9600 ,1000,fin, [Wait (110), Str tableau]                
            
   donnee=   tableau[0]
   If donnee = 65 Then E_ana       'tat des entres analogiques An0  An7 (A)
   If donnee = 76 Then E_log       'tat des entres logiques port D Rd0  Rd7 (L)
   If donnee = 83 Then S_log       'sortie sur port B Rb0  Rb7 (S)
   If donnee = 77 And tableau[1]= 49 Then marche = 1 'bouton marche appuy (M)
   If donnee = 77 And tableau[1]= 48 Then marche = 0 'bouton marche appuy (M)
        
   If marche =0 Then Low led : clrf PORTB            'si variable marche =0
   GoTo debut

'le port B de Rb0  Rb7 reprsente les sorties logiques               
S_log:
        
    If marche =0 Then GoTo fin
    PORTB= tableau[1]           'le 2eme octet reu est transfr sur le port B
    GoTo fin

'les ports A et E de AN0  AN7 reprsentent les entres analogiques
   
E_ana:
    If marche =0 Then GoTo fin
    ADCON1=%00000111                    'voies An0-AN7 actives 
    donnee_ana=0
    ADCON2=%10100010                    'TAD = 8 Fosc/32 (voir registre ADCON2)

'********* Voie AN0 **********

   ADCON0=%00000001                     'config registre ADCON0 (Alim + slection voie AN0)
   DelayMS 100                          'temporisation de 100 mS 
   ADCON0.1 = 1                         'lancement de la conversion (bit 1 de ADCON0)

Loop:
       If ADCON0.1=1 Then GoTo Loop                     'test si la conversion est termine (bit 2 =0)
       donnee_ana=ADRESL                                'transfre 8 bits poids faible du rsultat dans donnee_ana
       donnee_ana.8 = ADRESH.0                          'transfre 9eme bit (ADRESH) du rsultat dans donnee_ana
       donnee_ana.9=ADRESH.1                            'transfre 10eme bit (ADRESH) du rsultat dans donnee_ana          
       SerOut PORTC.6,T9600,["s1: ", Dec donnee_ana," " ]'on transfre la valeur sur la LS       

'********* Voie AN1 **********
        
   ADCON0=%00000101                     'config registre ADCON0 (Alim + slection chane AN1)
   DelayMS 100
   ADCON0.1 = 1
Loop1:
       If ADCON0.1=1 Then GoTo Loop1                     'test si la conversion est termine (bit 2 =0)
       donnee_ana=ADRESL                                'transfre 8 bits poids faible du rsultat dans donnee_ana
       donnee_ana.8 = ADRESH.0                          'transfre 9eme bit (ADRESH) du rsultat dans donnee_ana
       donnee_ana.9=ADRESH.1                            'transfre 10eme bit (ADRESH) du rsultat dans donnee_ana          
       SerOut PORTC.6,T9600,["s2: ",Dec donnee_ana," " ]'on transfre la valeur sur la LS       

'********* Voie AN2 **********
        
   ADCON0=%00001001                     'config registre ADCON0 (Alim + slection chane AN2)
   DelayMS 100
   ADCON0.1 = 1
Loop2:
       If ADCON0.1=1 Then GoTo Loop2                     'test si la conversion est termine (bit 2 =0)
       donnee_ana=ADRESL                                'transfre 8 bits poids faible du rsultat dans donnee_ana
       donnee_ana.8 = ADRESH.0                          'transfre 9eme bit (ADRESH) du rsultat dans donnee_ana
       donnee_ana.9=ADRESH.1                            'transfre 10eme bit (ADRESH) du rsultat dans donnee_ana          
       SerOut PORTC.6,T9600,["s3: ",Dec donnee_ana," " ]'on transfre la valeur sur la LS       

'********* Voie AN3 **********

   ADCON0=%00001101                     'config registre ADCON0 (Alim + slection chane AN3)
   DelayMS 100
   ADCON0.1 = 1
Loop3:
       If ADCON0.1=1 Then GoTo Loop3                     'test si la conversion est termine (bit 2 =0)
       donnee_ana=ADRESL                                'transfre 8 bits poids faible du rsultat dans donnee_ana
       donnee_ana.8 = ADRESH.0                          'transfre 9eme bit (ADRESH) du rsultat dans donnee_ana
       donnee_ana.9=ADRESH.1                            'transfre 10eme bit (ADRESH) du rsultat dans donnee_ana          
       SerOut PORTC.6,T9600,["s4: ",Dec donnee_ana," " ]'on transfre la valeur sur la LS       

'********* Voie AN4 **********

   ADCON0=%00010001                     'config registre ADCON0 (Alim + slection chane AN4)
   DelayMS 100
   ADCON0.1 = 1
Loop4:
       If ADCON0.1=1 Then GoTo Loop4                     'test si la conversion est termine (bit 2 =0)
       donnee_ana=ADRESL                                'transfre 8 bits poids faible du rsultat dans donnee_ana
       donnee_ana.8 = ADRESH.0                          'transfre 9eme bit (ADRESH) du rsultat dans donnee_ana
       donnee_ana.9=ADRESH.1                            'transfre 10eme bit (ADRESH) du rsultat dans donnee_ana          
       SerOut PORTC.6,T9600,["s5: ",Dec donnee_ana," " ]'on transfre la valeur sur la LS       

'********* Voie AN5 **********

   ADCON0=%00010101                     'config registre ADCON0 (Alim + slection chane AN5)
   DelayMS 100
   ADCON0.1 = 1
Loop5:
       If ADCON0.1=1 Then GoTo Loop5                     'test si la conversion est termine (bit 2 =0)
       donnee_ana=ADRESL                                'transfre 8 bits poids faible du rsultat dans donnee_ana
       donnee_ana.8 = ADRESH.0                          'transfre 9eme bit (ADRESH) du rsultat dans donnee_ana
       donnee_ana.9=ADRESH.1                            'transfre 10eme bit (ADRESH) du rsultat dans donnee_ana          
       SerOut PORTC.6,T9600,["s6: ",Dec donnee_ana," " ]'on transfre la valeur sur la LS       

'********* Voie AN6 **********

   ADCON0=%00011001                     'config registre ADCON0 (Alim + slection chane AN6)
   DelayMS 100
   ADCON0.1 = 1
Loop6:
       If ADCON0.1=1 Then GoTo Loop6                     'test si la conversion est termine (bit 2 =0)
       donnee_ana=ADRESL                                'transfre 8 bits poids faible du rsultat dans donnee_ana
       donnee_ana.8 = ADRESH.0                          'transfre 9eme bit (ADRESH) du rsultat dans donnee_ana
       donnee_ana.9=ADRESH.1                            'transfre 10eme bit (ADRESH) du rsultat dans donnee_ana          
       SerOut PORTC.6,T9600,["s7: ",Dec donnee_ana," " ]'on transfre la valeur sur la LS       

'********* Voie AN7 **********

   ADCON0=%00011101                     'config registre ADCON0 (Alim + slection chane AN6)
   DelayMS 100
   ADCON0.1 = 1
Loop7:
       If ADCON0.1=1 Then GoTo Loop7                     'test si la conversion est termine (bit 2 =0)
       donnee_ana=ADRESL                                'transfre 8 bits poids faible du rsultat dans donnee_ana
       donnee_ana.8 = ADRESH.0                          'transfre 9eme bit (ADRESH) du rsultat dans donnee_ana
       donnee_ana.9=ADRESH.1                            'transfre 10eme bit (ADRESH) du rsultat dans donnee_ana          
       SerOut PORTC.6,T9600,["s8: ",Dec donnee_ana," " ]'on transfre la valeur sur la LS       

    GoTo fin

        'le port D de RD0  RD7 reprsente les entres logiques
E_log:
        If marche =0 Then GoTo fin
        donnee = PORTD
        SerOut PORTC.6,T9600,["E:",Dec donnee," " ] 'transfert du port D sur la LS
                
fin:
        If marche = 1 Then 
            Toggle led           'inversion de l'tat de la led
        Else
            Low led
        End If             
        GoTo debut               'retour au dbut du programme

        End                      'fin du programme



