'**********************************************************
' Apprendre la programmation des PIC II                   *
' Platine  relais avec HTR                               *
' Quartz : 20 Mhz  -  PIC 18F4520                         *           
' Version : 1.0 - 09                                      *
' Auteur : PM                                             *
'*********************************************************
  
' directives
         Device 18F4520     
         Declare serial_data 8  
         Symbol T9600 = 84	NO_LIST
 
 ' paramtrage des registres de direction des ports 
         TRISA = %00000000
         TRISB = %00000000
         TRISD = %00000011
         TRISC = %00000000 

 ' dclaration des variables utilises 
        Symbol inter = PORTD.0
        Symbol inter_prog=PORTD.1  
        Symbol inhibe_prog=PORTC.3        
        Symbol led_prog=PORTB.1
        Symbol led = PORTB.0

        Symbol rst =PORTD.2
        Symbol dta = PORTD.3
        Symbol clk = PORTC.4
        
        Symbol relais1 = PORTB.7
        Symbol relais2 = PORTB.6
        Symbol relais3 = PORTB.5
        Symbol relais4 = PORTB.4
        Symbol relais5 = PORTB.3
        Symbol relais6 = PORTB.2
        
        Dim passage1 As Bit    
        Dim passage2 As Bit
        Dim passage3 As Bit
        Dim passage4 As Bit    
        Dim passage5 As Bit
        Dim passage6 As Bit

        Dim allume As Bit
        Dim eteint As Bit
        Dim raz As Bit
        
        Dim seconde As Byte
        Dim minute As Byte
        Dim heure As Byte
        Dim jour As Byte
        Dim mois As Byte 
        Dim annee As Byte
        Dim n_jour As Byte
        Dim nom_jour As Byte
        Dim jour_j As Bit
        Dim valid As Byte
        
        Dim tableau[7] As Byte
        Dim progr[124] As Byte
        Dim index As Byte
        Dim index2 As Byte
                
        Dim val_relais1 As Byte
        Dim val_relais2 As Byte 
        Dim val_relais3 As Byte
        Dim val_relais4 As Byte
        Dim val_relais5 As Byte
        Dim val_relais6 As Byte
        Dim relais_3_4 As Bit
        
        Dim creneau1 As Byte
        Dim creneau2 As Byte
        Dim creneau3 As Byte
        Dim creneau4 As Byte
        Dim creneau5 As Byte
        Dim creneau6 As Byte


' Version du logiciel

    EWrite 200, ["HTR version 1.0 - P.Mayeux - 2011"]
  
    'init
    Low PORTB
    High led
    High led_prog
    High inhibe_prog
    DelayMS 1000
    Low led
    Low led_prog    

    'charge le tableau avec le contenu en eprom
    For index = 0 To 123
        progr[index]= ERead index
    Next index


programm:
    'Programmation des horaires d'enclenchement des relais
    If inter_prog=1 Then
            
            High led_prog
            Low led
            SerIn PORTC.7 , T9600 ,2000,time_out, [Wait (66), Str progr] 
            DelayMS 2000
            
            For index = 0 To 123
                EWrite index,[progr[index]]
            Next index
            
            DelayMS 1000
            SerOut PORTC.6 , T9600 , ["Programmation enregistree : " ] 
            DelayMS 1000
            Low led_prog
            DelayMS 500 
    End If               
 
    
raz1:    
    'Mise  l'heure de l'horloge temps rel      
    If inter=1 Then
            
            High led
            High led_prog
            SerIn PORTC.7 , T9600 ,2000,time_out, [Wait (65), Str tableau]                
            
            heure=   tableau[0]
            minute =   tableau[1]
            seconde=   tableau[2]
            jour=   tableau[3]
            mois=   tableau[4]
            annee=   tableau[5]
            n_jour= tableau[6]
            
            DelayMS 1200
            SerOut PORTC.6 , T9600 , ["Modification enregistree : " , HEX2 heure,":",   HEX2 minute,":",   HEX2 seconde, " j:",Dec n_jour] 
            DelayMS 1200
                        
            ' dsactivation de la protection du ds 1302
            High rst
            SHOut dta,clk,0,[$8E] '8E
            SHOut dta,clk,0,[$0] '00
            Low rst
            DelayMS 100
            
            ' recharge autorise de la capacit de sauvegarde
            High rst
            SHOut dta,clk,0,[$90] '90
            SHOut dta,clk,0,[$A5] 'A5
            Low rst
            DelayMS 100

            
            'mise  l'heure des heures
            High rst
            SHOut dta,clk,0,[$84] 
            SHOut dta,clk,0,[heure] 
            Low rst
            DelayMS 100
            
            'mise  l'heure des minutes
            High rst
            SHOut dta,clk,0,[$82] 
            SHOut dta,clk,0,[minute] 
            Low rst
            DelayMS 100
            
            'mise  l'heure des secondes
             High rst
            SHOut dta,clk,0,[$80] 
            SHOut dta,clk,0,[seconde] 
            Low rst
            DelayMS 100
            
            'mise  jour de l'anne
            High rst
            SHOut dta,clk,0,[$8C] 
            SHOut dta,clk,0,[annee] 
            Low rst
            DelayMS 100
            
            'mise  jour du mois
            High rst
            SHOut dta,clk,0,[$88] 
            SHOut dta,clk,0,[mois] 
            Low rst
            DelayMS 100
            
            'mise  jour du jour
            High rst
            SHOut dta,clk,0,[$86] 
            SHOut dta,clk,0,[jour] 
            Low rst
            DelayMS 1000
            
            'mise  jour du Numro de jour  de la semaine
            High rst
            SHOut dta,clk,0,[$8A] 
            SHOut dta,clk,0,[n_jour] 
            Low rst
            DelayMS 1000

            Low led
            Low led_prog


    End If

time_out: 
           Low PORTB
           creneau1=1           
           creneau2=1
           creneau3=1
           creneau4=1
           creneau5=1
           creneau6=1
           
           'relais 3 et 4
           passage1 = 0
           passage2 = 0
           passage3 = 0      
           passage4 = 0
           passage5 = 0
           passage6 = 0
           val_relais4=0                 
           val_relais3=0 
           relais_3_4=0                
           
debut:
            
            If inter=1 And inter_prog= 0 Then GoTo raz1    'demande de remise  l'heure
            If inter_prog=1 And inter=0 Then GoTo programm
            
            Low led_prog
            
            'recupration des minutes
            High led
            High rst
            SHOut dta,clk,0,[$83] 
            SHIn dta,clk,1 ,[minute] 
            DelayMS 100
            
            Low led 
            Low rst 
            
            'recupration des secondes
            High led
            High rst
            SHOut dta,clk,0,[$81] 
            SHIn dta,clk,1 ,[seconde] 
            DelayMS 100
            
            Low led 
            Low rst             
            
            'recupration des heures
            High led
            High rst
            SHOut dta,clk,0,[$85] 
            SHIn dta,clk,1 ,[heure] 
            DelayMS 100
            
            Low led 
            Low rst   
            
            'recupration du jour
            High led
            High rst
            SHOut dta,clk,0,[$87] 
            SHIn dta,clk,1 ,[jour] 
            DelayMS 100
            
            Low led 
            Low rst 
            
            'recupration du mois
            High led
            High rst
            SHOut dta,clk,0,[$89] 
            SHIn dta,clk,1 ,[mois] 
            DelayMS 100
            
            Low led 
            Low rst             
            
            'recupration de l'anne
            High led
            High rst
            SHOut dta,clk,0,[$8D] 
            SHIn dta,clk,1 ,[annee] 
            DelayMS 100
            
            Low led 
            Low rst   
            
            'recupration du numro du jour de la semaine
            High led
            High rst
            SHOut dta,clk,0,[$8B] 
            SHIn dta,clk,1 ,[n_jour] 
            DelayMS 100
            
            Low led 
            Low rst   
            
           If n_jour = $1 Then nom_jour="D"            
           If n_jour = $2 Then nom_jour="L"
           If n_jour = $3 Then nom_jour="M"
           If n_jour = $4 Then nom_jour="m"
           If n_jour = $5 Then nom_jour="J"
           If n_jour = $6 Then nom_jour="V"
           If n_jour = $7 Then nom_jour="S"

           DelayMS 200         
            
            ' +++++++++++ relais 1 +++++++++++
            jour_j=0
            index=12
            Call determine_jour12
            
            index=0
            If jour_j=1 Then Call relais_1
            'voteur
            If val_relais1=1 Then High relais1 
            If val_relais1=0 Then Low relais1 
  
            ' +++++++++++ relais 2 +++++++++++
            jour_j=0
            index=26
            Call determine_jour12
            
            index=14
            If jour_j=1 Then Call relais_2
            'voteur
            If val_relais2=1 Then High relais2 
            If val_relais2=0 Then Low relais2 
                   
            ' +++++++++++ relais 3 +++++++++++
            
            index2=40
            index=28
            valid=58
            relais_3_4=0
            '*********  Heure 1 *********
            Call relais_3_ou_4            
            passage1 = val_relais3
            index2=index2 + 3
            index=index + 4
             '********* Heure 2 ********
            
            Call relais_3_ou_4
            passage2 = val_relais3
            index2=index2 + 3
            index=index + 4
             '********* Heure 3 ********
            
            Call relais_3_ou_4
            passage3 = val_relais3

            'voteur
            If passage1 =1 Or passage2 =1 Or passage3 =1 Then 
            High relais3 
            Else
            Low relais3 
            End If
            
            ' +++++++++++ relais 4 +++++++++++
 
            index2=71
            index=59
            valid=89 
            relais_3_4=1
            '*********  Heure 1 *********
            Call relais_3_ou_4           
            passage4 = val_relais4
            index2=index2 + 3
            index=index + 4
             '********* Heure 2 ********
            
            Call relais_3_ou_4
            passage5 = val_relais4
            index2=index2 + 3
            index=index + 4
             '********* Heure 3 ********
            
            Call relais_3_ou_4
            passage6 = val_relais4

            'voteur
            If passage4 =1 Or passage5 =1 Or passage6 =1 Then             
            High relais4 
            Else
            Low relais4      
            End If
            
            ' +++++++++++ relais 5 +++++++++++
            jour_j=0
            index=102
            index2 = 103
            Call determine_jour56            
            
            index=90
            If jour_j=1 Then Call relais_5
            
            'voteur
            If val_relais5=1 Then High relais5 
            If val_relais5=0 Then Low relais5 

             ' +++++++++++ relais 6 +++++++++++
            jour_j=0
            index=119
            index2 = 120
            Call determine_jour56            
            index=107
            If jour_j=1 Then Call relais_6
            
            'voteur
            If val_relais6=1 Then High relais6 
            If val_relais6=0 Then Low relais6 
            
         
          '******* renvoi de l'heure vers le PC *******
            If inter=1 And inter_prog=1 Then Call affich                
           
GoTo debut

affich:

           
           SerOut PORTC.6 , T9600 , [ HEX2 heure,":", HEX2 minute,":", HEX2 seconde," - " ,HEX2 jour, "/", HEX2 mois, "/20" ,HEX2 annee, " - " ,nom_jour] 

           DelayMS 1000
           Return

determine_jour56:

            If progr[index]<9 And n_jour= progr[index]Then jour_j=1         'jour spcifi           
            If progr[index]=9 And n_jour>1 And n_jour < 7  Then jour_j=1    'lundi au vendredi
            If progr[index]=8 And n_jour=1 Or n_jour=7  Then jour_j=1       'samedi & dimanche           
            If progr[index]=$A  Then jour_j=1                               'tous les jours
            If progr[index + 4]=0 Then jour_j=0                             'valid  0
            If progr[index2 + 1]<> mois Or progr[index2 + 2]<> annee Then jour_j=0
            Return

determine_jour12:
            If progr[index]<9 And n_jour= progr[index] Then jour_j=1       'jour spcifi           
            If progr[index]=9 And n_jour>1 And n_jour < 7 Then jour_j=1    'lundi au vendredi
            If progr[index]=8 And n_jour=1 Or n_jour=7 Then jour_j=1       'samedi & dimanche           
            If progr[index]=$A Then jour_j=1                               'tous les jours
            If progr[index + 1]=0 Then jour_j=0                            'valid  0
            Return

relais_1:
            If   heure =  progr[index] And minute >=  progr[index + 1] And creneau1=1  Then val_relais1=1
            If   heure =  progr[index + 2] And  minute >=  progr[index + 3] And creneau1=1 Then val_relais1=0 : creneau1=2
            If   val_relais1=0 Then  creneau1=2           
            
            If  heure =  progr[index + 4] And  minute >=  progr[index + 5] And creneau1=2 Then val_relais1=1                 
            If  heure =  progr[index + 6] And  minute >=  progr[index + 7] And creneau1=2 Then val_relais1=0  : creneau1=3
            If  val_relais1=0 Then  creneau1=3
            
            If  heure =  progr[index + 8] And  minute >=  progr[index + 9] And creneau1=3 Then val_relais1=1                                                    
            If  heure =  progr[index + 10] And  minute >=  progr[index + 11] And creneau1=3 Then val_relais1=0            
            If val_relais1=0 Then creneau1 = 1
            Return    
            
relais_2:
            
            If   heure =  progr[index] And minute >=  progr[index + 1] And creneau2=1  Then val_relais2=1
            If   heure =  progr[index + 2] And  minute >=  progr[index + 3] And creneau2=1 Then val_relais2=0 : creneau2=2
            If   val_relais2=0 Then  creneau2=2           
            
            If  heure =  progr[index + 4] And  minute >=  progr[index + 5] And creneau2=2 Then val_relais2=1                 
            If  heure =  progr[index + 6] And  minute >=  progr[index + 7] And creneau2=2 Then val_relais2=0  : creneau2=3
            If  val_relais2=0 Then  creneau2=3
            
            If  heure =  progr[index + 8] And  minute >=  progr[index + 9] And creneau2=3 Then val_relais2=1                                                    
            If  heure =  progr[index + 10] And  minute >=  progr[index + 11] And creneau2=3 Then val_relais2=0            
            If val_relais2=0 Then creneau2 = 1
            Return               
            
relais_3_ou_4:
            
            allume=0
            eteint=0
            raz = 0
            
            'date de dbut 
            If jour >=progr[index2] And mois >=progr[index2 + 1] And annee >=progr[index2 + 2] And progr[valid]= 1 Then allume=1       'date spcifie                         
            
            'si date de fin est < date de dbut
            If progr[index2]> progr[index2 + 3] And progr[index2 + 1] >= progr[index2 + 4] And progr[index2 + 2] >= progr[index2 + 5] Then raz = 1            
            If progr[index2 + 1] > progr[index2 + 4] And progr[index2 + 2] >= progr[index2 + 5] Then raz = 1            
            If progr[index2 + 2] > progr[index2 + 5] Then raz = 1            
            
            'date de fin 
            index2=index2 + 3 
            If jour >= progr[index2] And mois >=progr[index2 + 1] And annee >=progr[index2 + 2] And progr[valid]= 1 Then eteint=1                      
                        
            'calcul horaire 1
            'marche  
            If relais_3_4=0 And allume=1 And heure = progr[index] And minute = progr[index + 1]  Then val_relais3 = 1         
            If relais_3_4=1 And allume=1 And heure = progr[index] And minute = progr[index + 1]  Then val_relais4 = 1         

            'arret
            If relais_3_4=0 And eteint=1 And heure = progr[index + 2] And minute = progr[index + 3] Then val_relais3 = 0  
            If relais_3_4=0 And raz = 1 Then val_relais3 = 0
            If relais_3_4=1 And eteint=1 And heure = progr[index + 2] And minute = progr[index + 3] Then val_relais4 = 0  
            If relais_3_4=1 And raz = 1 Then val_relais4 = 0
            
            Return 


relais_5:
            If   heure =  progr[index] And minute >=  progr[index + 1] And creneau5=1  Then val_relais5=1
            If   heure =  progr[index + 2] And  minute >=  progr[index + 3] And creneau5=1 Then val_relais5=0 : creneau5=2
            If   val_relais5=0 Then  creneau5=2           
            
            If  heure =  progr[index + 4] And  minute >=  progr[index + 5] And creneau5=2 Then val_relais5=1                 
            If  heure =  progr[index + 6] And  minute >=  progr[index + 7] And creneau5=2 Then val_relais5=0  : creneau5=3
            If  val_relais5=0 Then  creneau5=3
            
            If  heure =  progr[index + 8] And  minute >=  progr[index + 9] And creneau5=3 Then val_relais5=1                                                    
            If  heure =  progr[index + 10] And  minute >=  progr[index + 11] And creneau5=3 Then val_relais5=0            
            If val_relais5=0 Then creneau5 = 1
            Return    
        
relais_6:
            If   heure =  progr[index] And minute >=  progr[index + 1] And creneau6=1  Then val_relais6=1
            If   heure =  progr[index + 2] And  minute >=  progr[index + 3] And creneau6=1 Then val_relais6=0 : creneau6=2
            If   val_relais6=0 Then  creneau6=2           
            
            If  heure =  progr[index + 4] And  minute >=  progr[index + 5] And creneau6=2 Then val_relais6=1                 
            If  heure =  progr[index + 6] And  minute >=  progr[index + 7] And creneau6=2 Then val_relais6=0  : creneau6=3
            If  val_relais6=0 Then  creneau6=3
            
            If  heure =  progr[index + 8] And  minute >=  progr[index + 9] And creneau6=3 Then val_relais6=1                                                    
            If  heure =  progr[index + 10] And  minute >=  progr[index + 11] And creneau6=3 Then val_relais6=0            
            If val_relais6=0 Then creneau6 = 1
            Return    
End           
            
