'*********************************************************
' Apprendre la programmation des PIC high performance    *
' Acquisition de donnes avec carte SD                   *
' Pic utilis : 18 F 4520                                *
' Quartz : 20 Mhz                                        *
' Version 1.2 03/2011                                    *
' Auteur Pascal Mayeux                                   *
'********************************************************        
  
' directives
       
         Device 18F4520
         Declare serial_data 8  
         Symbol T9600 = 84	NO_LIST
         XTAL=20

'dclaration pour le port B
         TRISB = %01111111   
         
' Dclaration entre analogique AN4

    TRISA = %11111111         
    ADIN_RES = 10
    ADIN_TAD = FRC
    ADIN_STIME = 100
    ADCON1=%10000000
    PORTB_PULLUPS=On  



 ' dclaration des variables utilises 
 
        Dim f As Word
        Dim g As Byte
        Dim d5 As Bit
        Dim d6 As Bit
        Dim d7 As Bit
        Dim d8 As Bit
        Dim enregistre As Bit
        Dim periode As DWord
       
         
 ' dclaration des variables pour HTR
 
        Symbol rst =PORTC.3
        Symbol dta = PORTD.0
        Symbol clk = PORTD.1
        
        Dim seconde As Byte
        Dim minute As Byte
        Dim heure As Byte
        Dim jour As Byte
        Dim mois As Byte 
        Dim annee As Byte
        Dim n_jour As Byte
        Dim nom_jour As Byte
        Dim jour_j As Bit
        Dim jour_j2 As Bit
        Dim jour_j3 As Bit
        Dim valid As Byte
        Dim creneau As Byte
        
        Dim tableau[7] As Byte
        Dim progr[15] As Byte
        Dim index As Byte
        Dim index2 As Byte
        
        Dim ajout1 As Byte
        Dim ajout2 As Byte
        Dim ajout3 As Byte
        Dim ajout4 As Byte
        Dim ajout5 As Byte
        Dim ajout6 As Byte
        
        Dim fois As Bit
        Dim calcul_delai As DWord

 ' dclaration des symbols utiliss 

        'inter 
        Symbol inter1 = PORTA.4
        Symbol inter2=PORTA.5
               
        'led
        Symbol led1=PORTC.5
       
        'sonde de temprature
        Symbol dq=PORTD.2
        Dim temp As Word
        Dim degres As Byte
        Dim hold As Byte
        
        'carte SD
        Symbol tx_sd = PORTB.6
        Symbol rx_sd = PORTB.7 
        Symbol raz = PORTB.5   
        Dim serdata As Byte    
        
        'entrees logiques
        Symbol entree1 = PORTB.1
        Symbol entree2 = PORTB.2
        Symbol entree3 = PORTB.3        
        Symbol entree4 = PORTB.4
        
        'entrees analogiques
        Dim d1 As Word
        Dim d2 As Word
        Dim d3 As Word
        Dim d4 As Word
          
        'tempo
        Symbol tempo = 1000
               
        'init
        High led1
        DelayMS 1000
        Low led1
        DelayMS 1000
        enregistre=0
        creneau=1
        
        'init de la sd carte
        High raz  
        SerOut tx_sd , T9600 , ["init",13,10] 
        DelayMS 500
 
            
' Version du logiciel

    EWrite 100, ["Acquisition avec carte SD version 1.1 - (c) P.Mayeux - 03/2008"]
    Low raz
    f=0
    fois = 1

    'charge le tableau avec le contenu en eprom
    For index = 0 To 14
        progr[index]= ERead index
    Next index
    
debut:

            
    '******* renvoi de l'heure vers le PC *******                       'sur platine
    
            If inter1=0 And ADIn 4 < 100 Then            
                Call affich               'inter2=on inter1=on
            End If

    '******* mise  l'heure platine *******

            If ADIn 4 < 100 And inter1=1 Then  
                Call mise_h               'inter1=off inter2=on  
            End If

    '******* Programmation des enregistrements *******
  
            If inter1=0 And ADIn 4 > 100 Then              
                 Call programmation        'inter1=on inter2=off
            End If
            
    '******* mode debug *******
  
            'If PORTC.2=0  Then              
                 'Call essai        
            'End If

                                  
'************* Boucle principale ****************
               
               
              Toggle led1
          
    '******* Lecture HTR *******

            'recupration des minutes
            High rst
            SHOut dta,clk,0,[$83] 
            SHIn dta,clk,1 ,[minute] 
            DelayMS 30
            
            Low rst 
            
            'recupration des secondes
             High rst
            SHOut dta,clk,0,[$81] 
            SHIn dta,clk,1 ,[seconde] 
            DelayMS 30
            
            Low rst             
            
            'recupration des heures
            High rst
            SHOut dta,clk,0,[$85] 
            SHIn dta,clk,1 ,[heure] 
            DelayMS 30
            
            Low rst   
            
                       
            'recupration du jour
            High rst
            SHOut dta,clk,0,[$87] 
            SHIn dta,clk,1 ,[jour] 
            DelayMS 30
            
            Low rst 
            
            'recupration du mois
            High rst
            SHOut dta,clk,0,[$89] 
            SHIn dta,clk,1 ,[mois] 
            DelayMS 30
            
            Low rst             
            
            'recupration de l'anne
            High rst
            SHOut dta,clk,0,[$8D] 
            SHIn dta,clk,1 ,[annee] 
            DelayMS 30
            
            Low rst   
            
            'recupration du numro du jour de la semaine
            High rst
            SHOut dta,clk,0,[$8B] 
            SHIn dta,clk,1 ,[n_jour] 
            DelayMS 30
            
            Low rst   
            
           If n_jour = $1 Then nom_jour="D"            
           If n_jour = $2 Then nom_jour="L"
           If n_jour = $3 Then nom_jour="M"
           If n_jour = $4 Then nom_jour="m"
           If n_jour = $5 Then nom_jour="J"
           If n_jour = $6 Then nom_jour="V"
           If n_jour = $7 Then nom_jour="S"
           
            ajout1=" "
            ajout2=" "
            ajout3=" "
            ajout4=" "
            ajout5=" "
            ajout6=" "
            
            If  seconde <= 9 Then ajout1="0"        
            If  minute <=9 Then ajout2="0" 
            If  heure <= 9 Then ajout3="0" 
            If  jour <= 9 Then ajout4="0" 
            If  mois <= 9 Then ajout5="0" 
            If  annee <= 9 Then ajout6="0" 

            
            DelayMS 50         
            
            ' +++++++++++ calcul moment d'acquisition +++++++++++
            jour_j=0
            index=12
            If progr[index]<9 And n_jour= progr[index] Then jour_j=1       'jour spcifi           
            If progr[index]=9 And n_jour>1 And n_jour < 7 Then jour_j=1    'lundi au vendredi
            If progr[index]=8 And n_jour=1 Or n_jour=7 Then jour_j=1       'samedi & dimanche           
            If progr[index]=$A Then jour_j=1                               'tous les jours
            
            periode=progr[index + 1]
            index=0
            
            'enregistre=0
            Call calcul
            
            'enregistrement variables
            If enregistre=1 Then Call acqui
            If enregistre=0 Then fois = 1
            
           
               
GoTo debut            
    
calcul:
            
            
           
            
            'marche
       
        If jour_j=1 Then
  
 
            If   heure =  progr[index] And minute >=  progr[index + 1] And creneau=1  Then enregistre=1 
            If   heure =  progr[index + 2] And  minute >=  progr[index + 3] And creneau=1 Then enregistre=0 : creneau=2
            If   enregistre=0 Then  creneau=2           
            
            If  heure =  progr[index + 4] And  minute >=  progr[index + 5] And creneau=2 Then enregistre=1                 
            If  heure =  progr[index + 6] And  minute >=  progr[index + 7] And creneau=2 Then enregistre=0  : creneau=3
            If   enregistre=0 Then  creneau=3
            
            If  heure =  progr[index + 8] And  minute >=  progr[index + 9] And creneau=3 Then enregistre=1                                                     
            If  heure =  progr[index + 10] And  minute >=  progr[index + 11] And creneau=3 Then enregistre=0              
            If enregistre = 0 Then creneau = 1

        End If
            
              
         Return
                    
mise_h:    
            Toggle led1
            SerIn PORTC.7 , T9600 ,2000,time_out, [Wait (65), Str tableau]                
            
            heure=   tableau[0]
            minute =   tableau[1]
            seconde=   tableau[2]
            jour=   tableau[3]
            mois=   tableau[4]
            annee=   tableau[5]
            n_jour= tableau[6]
            
            DelayMS 1000
            SerOut PORTC.6 , T9600 , ["Modification enregistre : " , HEX heure,":",   HEX minute,":",   HEX seconde,13, " j:",n_jour] 
            DelayMS 1000
            
            
            ' dsactivation de la protection du ds 1302
            High rst
            SHOut dta,clk,0,[$8E] '8E
            SHOut dta,clk,0,[$0] '00
            Low rst
            DelayMS 100
            
            ' recharge autorise de la capacit de sauvegarde
            High rst
            SHOut dta,clk,0,[$90] '90
            SHOut dta,clk,0,[$A5] 'A5
            Low rst
            DelayMS 100

            'debug 
            Toggle led1
            
            'mise  l'heure des heures
            High rst
            SHOut dta,clk,0,[$84] 
            SHOut dta,clk,0,[heure] 
            Low rst
            DelayMS 100
            
            'mise  l'heure des minutes
            High rst
            SHOut dta,clk,0,[$82] 
            SHOut dta,clk,0,[minute] 
            Low rst
            DelayMS 100
            
            'mise  l'heure des secondes
            High rst
            SHOut dta,clk,0,[$80] 
            SHOut dta,clk,0,[seconde] 
            Low rst
            DelayMS 100
            
            'mise  jour de l'anne
            High rst
            SHOut dta,clk,0,[$8C] 
            SHOut dta,clk,0,[annee] 
            Low rst
            DelayMS 100
            
            'mise  jour du mois
            High rst
            SHOut dta,clk,0,[$88] 
            SHOut dta,clk,0,[mois] 
            Low rst
            DelayMS 100
            
            'mise  jour du jour
            High rst
            SHOut dta,clk,0,[$86] 
            SHOut dta,clk,0,[jour] 
            Low rst
            DelayMS 1000
            
            'mise  jour du Numro de jour  de la semaine
            High rst
            SHOut dta,clk,0,[$8A] 
            SHOut dta,clk,0,[n_jour] 
            Low rst
            DelayMS 1000             
            Return
    
    
acqui:            
            High led1             
            DelayMS 50 
            High raz        
           
            'debug
            If periode<2 Then periode=2
            calcul_delai=(periode * 1000)- 1000

                            
                ' ************************ mesure entres ana *************************
                d1=  ADIn 0
                DelayMS 5
                d2=  ADIn 1
                DelayMS 5
                d3=  ADIn 2
                DelayMS 5
                d4=  ADIn 3
                DelayMS 5
                
                ' ********************** mesure entres logiques **********************
                d5=PORTB.1
                d6=PORTB.2
                d7=PORTB.3
                d8=PORTB.4                
                
                ' ************* mesure de la temprature avec ds 1820 *****************
                OWrite dq,1,[$CC,$44]   'envoi calcul temprature vers ds1820
                Repeat
                    DelayMS 25
                    ORead dq,4,[hold]   'mise de la valeur reue dans la variable hold
                    Toggle led1
                Until hold <> 0
                OWrite dq,1,[$CC,$BE]
                ORead dq,2,[temp.LowByte,temp.HighByte,hold,hold,hold,hold,hold,degres]
                temp=(((temp>>1)*100)-25) + (((degres-hold)*100)/degres)
                '***********************************************************************


                ' ************* mesure de la temprature avec ds 18B20 *****************                 
                'OWrite dq, 1, [$CC, $4E, DumTh, DumTl, $5F] 'AD en 11 bits                 
                'OWrite dq,1,[$CC,$44]   'envoi calcul temprature vers dsb1820
                'Repeat
                    'DelayMS 30
                    'ORead dq,4,[hold]   'mise de la valeur reue dans la variable hold
                    'Toggle led1
                'Until hold <> 0
                'OWrite dq,1,[$CC,$BE]
                'ORead dq,2,[temp.LowByte,temp.HighByte,hold,hold,hold,hold,hold,degres]
                'temp=(((temp>>1)*100)-25) + (((degres-hold)*100)/degres)
                '***********************************************************************


           If fois = 1 Then 
            SerOut tx_sd , T9600 , ["fputs mesure.txt /a ","Priode : ",Dec periode ," seconde(s) ",  13,10] 
            DelayMS 150
           End If
           
            'datation vnement
            If fois = 1 Then
                DelayMS 150 
                SerOut tx_sd , T9600 , ["fputs mesure.txt /a ", "Date-Heure ",ajout4,HEX jour, "/", ajout5,HEX mois, "/20" ,ajout6,HEX annee, " - " ,ajout3 , HEX heure,":",ajout2 , HEX minute,":",ajout1 , HEX seconde , 13,10] 
                DelayMS 150
                fois=0
                g=0
            End If
            
              DelayMS 100             
             SerOut tx_sd , T9600 , ["fputs mesure.txt /a ", Dec temp/100,".", DEC2 temp," ; ", Dec d1," ; ",Dec d2," ; ",Dec d3," ; ",Dec d4, " ; " ,Dec d5," ; ", Dec d6," ; ", Dec d7," ; ", Dec d8," ; " ,13,10] 
            Low led1
            
            If calcul_delai < 65536 Then DelayMS calcul_delai
            If calcul_delai > 65535 Then 
                calcul_delai=calcul_delai-65535
                DelayMS 65535
                DelayMS calcul_delai
            End If
            
            g=g+1
                      
            Return

 
affich:
           Toggle led1 
           DelayMS 100
           SerOut PORTC.6 , T9600 , [ajout3 , HEX heure,":",ajout2 , HEX minute,":",ajout1 , HEX seconde," - " ,ajout4,HEX jour, "/", ajout5,HEX mois, "/20" ,ajout6,HEX annee, " - " ,nom_jour] 
           DelayMS 1000
           Return

programmation:
            
            High led1
            SerIn PORTC.7 , T9600 ,4000,time_out, [Wait (66), Str progr] 
            DelayMS 2000
            
            For index = 0 To 14
                EWrite index,[progr[index]]
            Next index
            
            DelayMS 1000
            SerOut PORTC.6 , T9600 , ["Programmation enregistree : " ,13,10] 
            DelayMS 500
            Low led1
            DelayMS 500 
            Return
            
time_out:
    
    For f=0 To 20
        Toggle led1
        DelayMS 100
    Next f

    GoTo debut



End
             
             

